open Tree (* on « importe » les définitions de tree.ml *)

let dump filename t = Draw.draw (fun i -> Printf.sprintf "%d" i) filename t

let test1 () =
  let t1 = add 1 (add 2 (add 3 empty)) (* = Leaf *) in
  let () = dump "img/test1_1.svg" t1 in
  let t2 = add 42 (add 43 (add 44 t1)) in
  dump "img/test1_2.svg" t2

let of_list l = List.fold_left (fun t e -> add e t) empty l
let t1 = of_list [ 1; 2; 3; 4; 5; 6 ]
let t2 = of_list [ 5; 6; 7; 8; 9; 10 ]

let test2 () =
  (* Question 3 *)
  (* fonction auxiliaire *)
  let tu = union t1 t2 in
  let () = dump "img/test2_union.svg" tu in
  let ti = inter t1 t2 in
  let () = dump "img/test2_inter.svg" ti in
  let td = diff t1 t2 in
  dump "img/test2_diff.svg" td

let test3 () =
  (* Question 4 *)
  (* La fonction plante si l'un des tests est faux *)
  assert (mem 5 t1);
  assert (mem 8 t2);
  assert (not (mem 10 t1));
  assert (fold (fun e l -> e :: l) t1 [] = [ 6; 5; 4; 3; 2; 1 ]);
  (* test d'iter, on affiche :*)
  iter (fun e -> Printf.printf "%d " e) t1;
  Printf.printf "\n"

let test4 () =
  (* test de la fonction partition *)
  let t = of_list [ 1; 2; 3; 4; 5; 6; 7; 8 ] in
  let tt, tf = partition (fun e -> e mod 2 = 0) t in
  dump "img/partition_true.svg" tt;
  dump "img/partition_false.svg" tf

let test5 () =
  (* test de la fonction elements *)
  let t = of_list [ 1; 10; 9; 8; 2; 3; 4; 5; 7; 6 ] in
  assert (elements t = [ 1; 2; 3; 4; 5; 6; 7; 8; 9; 10 ])

(* Question 9 *)
let tree_of_height h n b =
  let rec loop t n =
    if height t = h then t else
      let t = add n t in
      let n = if b then n + 1 else n - 1 in
      loop t n
    in loop empty n

(* Question 10 *)
let test6 () =
  let t4 = tree_of_height 4 100 false in
  let t8 = tree_of_height 8 102 true in
  let t = join_avl t4 101 t8 in
  dump "img/bal_4_8.svg" t


(* Question 11 *)
let test7 () =
  let l = [ 1;2;3;4;5;6;7;8;9;10] in
  let t = of_list l in
  let teven, todd = partition (fun e -> e mod 2  = 0) t in
  let s = union teven todd in
  dump "img/test7_1.svg" t;
  dump "img/test7_2.svg" s;
  (* test question 12*)
  assert (same_fringe t s)
  


let () = test7 ()
